Subject: RE: [mobile-ip] what optimistic DAD?

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Wed, 2 Jul 2003 08:07:15 +0100

Hi Ed,

I'm surprised this one comes from you. 

It's an interesting point but a bit far fetched to my taste. I better
understand constraints such as MIP being close to make RFC from Vijay.
For your point, a user may just not be able to unbind for the lack of
connectivity to the HA. Should he pay till lifetime expires? I suspect a
per byte fee such as GPRS is better suited. But it's a bit early and
misplaced for us to figure out how ISP will charge, isn't it?

Pascal

> -----Original Message-----
> From: Ed Remmell [mailto:[email-masked]]
> Sent: mardi 1 juillet 2003 17:43
> To: Pascal Thubert (pthubert); 'Nick 'Sharkey' Moore';
[email-masked]
> Subject: RE: [mobile-ip] what optimistic DAD?
> 
> Pascal -
> 
> I believe this is an entirely different issue - it is the issue of
> "sticky" registration, not really related to DAD although DAD does
come
> into play.
> 
> We worked this a bit, but there were some strong dissenting opinions
> (Vijay, I believe, was one) about having the HA quit proxying for the
MN
> and auto-deregister the MN's home address/care-of address binding when
> it detects that some node (perhaps not the MN) is using the MN's home
> address on the home link.
> 
> In retrospect, I agree with the outcome, which is the current "sticky"
> registration behavior in the HA. The MN must explicitly deregister its
> binding with the HA, else the HA keeps defending it and proxying for
it
> (provided the binding lifetime doesn't expire). The main reason why I
> agree with the outcome is I think that there will likely be some type
of
> fee charged by the HA (or ISP providing the HA service) to providing
the
> support for a MN to register a mobility binding, and given this, I
think
> it does make sense to have a more explicit mechanism (i.e. explicit
> deregistration BU) to turn off this support. Considering that this
> functionality in the HA will likely trigger something in a billing
> and/or accounting system, it seems to make sense to put that trigger
on
> a higher level message such as a deregistration BU rather than a
> lower-level (and not clearly related) protocol event such as DAD
> performed on the MN's home address by a different node. Anyways,
that's
> where I stand on this now.
> 
> Thanks.
> - Ed Remmell
> Elmic Systems, USA
> 
> > -----Original Message-----
> > From: [email-masked]
> > [mailto:[email-masked]] On Behalf Of
> > Pascal Thubert (pthubert)
> > Sent: Tuesday, July 01, 2003 2:06 AM
> > To: Nick 'Sharkey' Moore; [email-masked]
> > Subject: RE: [mobile-ip] what optimistic DAD?
> >
> >
> > Hi Nick
> >
> > By the way, there's MIP specific aspects to optimism that
> > maybe you could consider, making the draft even more
> > interesting for MIP.
> >
> > One thing is the DAD handling by the HA. Delays the BU
> > (uselessly in most cases as you know). Yet the HA is a proxy
> > so it should always be shut off by a newer (secured) binding
> > or the MN being home. This is not the behavior in the draft
> > today. A new registration takes DAD and is pretty sticky after that.
> >
> > We had a discussion on the subject on the ML that never
> > really concluded. The draft was changed so that the MN coming
> > home DADs its own address to find an eventual sticky binding
> > and the HA for it, in order to deregister, which was
> > consensually agreed upon.
> >
> > The second thing is, that IMHO, the proxy should be shut off
> > by the simple presence of the real owner of the address on
> > link, and that we should define the mechanism to ensure so.
> > Also, I still believe that the owner MN binding to a
> > different HA should cause the sticky binding in the old HA to
> > go silently. Seems to me that your mechanisms could be used
> > to do all that.
> >
> > What do you think?
> >
> > > -----Original Message-----
> > > From: Nick 'Sharkey' Moore [mailto:[email-masked]]
> > > Sent: mardi 1 juillet 2003 00:48
> > > To: [email-masked]
> > > Cc: Rajeev Koodli
> > > Subject: Re: [mobile-ip] what optimistic DAD?
> > >
> > > On 2003-06-30, Rajeev Koodli wrote:
> > > > Vijay Devarapalli wrote:
> > > > >
> > > > > convince IPv6 folks that OptiDAD is the way to go.
> > (infact I will
> > > > > support you on this). once they are convinced, we
> > > >
> > > > Count me in as well :-)
> > >
> > > Excellent!  Good to get some momentum behind the damned thing.
> > >
> > > > I am just not convinced that the current oDAD spec will work
> > > > efficiently when there is no ND entry at the router.
> > Unsolicited NA
> > in
> > > > this scenario is a waste.
> > >
> > > It's true that the unsolicited NA is a waste in this
> > situation, but on
> > > the other hand they're small packets and frankly 802.11 is pretty
> > > wasteful to start with.  Other L2s (eg: telephony stuff)
> > may be more
> > > number-of-messages-critical (I remember discussing this
> > with James in
> > > Yokohama) but then they're generally rather friendlier to
handovers
> > > anyway.
> > >
> > > > FNA provides an indication to the router to create an entry when
> > > > there isn't one. So, the message does not go waste and avoids a
> > > > round-trip. It also helps detect duplicates, if any, at
> > the router.
> > >
> > > Yeah, the big reason for Optimistic DAD is that it can work on an
> > > unmodified access router, admittedly at a penalty in extra
> > signalling.
> > >
> > > Either (a) traffic gets to NAR before MN sends that unsol
> > NA, or (b)
> > > it doesn't.
> > >
> > > We've ccvered (a) in this thread.
> > >
> > > In (b) there will be no NAR NC entry and so the NAR SHOULD
> > ignore the
> > > unsolicited NA.  Either traffic will arrive due to the prediction
> > > mechanism, or the MN will promptly send a BU back to it's
> > HA/MAP/CNs
> > > which will send traffic through to NCoA. Either way, when
> > traffic gets
> > > to NA, NAR will NS for NCoA and MN to reply with an NS (O=0, S=1),
> > > which will upgrade the NC entry from INCOMPLETE to REACHABLE.
> > >
> > > > The purpose of FNA here is to move the entry directly to
> > REACHABLE
> > > > so that the additional round-trip messages are avoided.
> > >
> > > Yeah, and I think that's the difference.  Optimistic DAD is
> > an attempt
> > > to make all this work ON AN UNMODIFIED NAR at the expense
> > of a couple
> > > of extra round-trips.  I think it's important that we get a
> > practical
> > > handover protocol which will work in Starbucks :-)
> > >
> > > -----Nick
> >
> >
> > ---
> > Incoming mail is certified Virus Free.
> > Checked by AVG anti-virus system (http://www.grisoft.com).
> > Version: 6.0.486 / Virus Database: 284 - Release Date: 5/29/2003
> >
> >
> 
> ---
> Outgoing mail is certified Virus Free.
> Checked by AVG anti-virus system (http://www.grisoft.com).
> Version: 6.0.486 / Virus Database: 284 - Release Date: 5/29/2003
>

---

From: "Ed Remmell" <[email-masked]>
Date: Wed, 2 Jul 2003 10:00:19 -0700

Pascal -

> I'm surprised this one comes from you.

Well, yes. I did initially argue strongly for this HA auto-deregister
capability (on detection of another node on the home link using the MN's
registered home address) you are recommending. It seems very fast, very
simple, etc., plus it avoids another failure scenario that can occur if
the MN power-cycles on a foreign link, forgets that it had already
registered a binding with HA #1 (which is still an active mobility
binding), and then does DHAAD, discovers HA #2, and tries to register
the same binding with HA #2 - which will fail due to a DAD failure
because HA #1 is still defending that home address.

Vijay, are you still strongly opposed to this HA auto-deregister
capability (upon detection of another node's DAD of the registered home
address) that Pascal is recommending? If so, then why? Is there a
technical reason, or is it just for the sake of minimizing changes to
the draft?

> It's an interesting point but a bit far fetched to my taste.

The ISP scenario with ISPs billing for Mobile IPv6 service (the ISP
provides access to the HA, and has the routable home network with a pool
of home addresses to assign to MNs) is a very real services scenario for
Mobile IPv6.

I assumed that the accounting/billing/administration folks would prefer
an explicit trigger like an authorized/authenticated deregistration BU
over the MN DAD of its home address on the home link.

Here's another point: the deregistration BU/BA exchange between the MN
and HA is protected (authorized and authenticated) using IPsec. DAD, on
the other hand, is not. Therefore the DAD mechanism is much more
vulnerable to a DoS attack. Perhaps your argument is that such DoS
attacks (since they would be link-local in scope, and there are already
other potential link-local scope DoS attacks such as spoofed Router
Advertisements) aren't something we should be too concerned about. I
could be persuaded to agree with that.

Also, what I saw in a response from Sharkey to your email was the
suggestion that most real-world deployments of MIPv6 will never have the
MN directly attached to its home network, in which case optimizing the
"MN return to home" scenario becomes somewhat of a moot point (however,
there is still the other failure scenario described above of multiple
HAs and MN forgets that it has an active binding and attempts to
register with a different HA - but then there can be some inter-HA
protocol implemented to smoothly recover from that failure scenario). I
agree with Sharkey on this point.

> I better understand constraints such as MIP being close to 
> make RFC from Vijay. For your point, a user may just not be 
> able to unbind for the lack of connectivity to the HA.

If there is lack of connectivity to the HA from a MN, then your scenario
of the MN returning to home and doing DAD on its home address is not
applicable, since then the HA would never see that DAD from the MN due
to lack of connectivity.

> Should 
> he pay till lifetime expires? I suspect a per byte fee such 
> as GPRS is better suited. But it's a bit early and misplaced 
> for us to figure out how ISP will charge, isn't it?

Yes. I agree it is a bit early and misplaced to figure out how the ISP
will charge.

I still like the explicit authorized/authenticated deregistration BU
trigger better than the HA auto-deregistration on detection of DAD that
you recommend. However, if there is enough technical justification for
making this simplification you recommend, then I'm certainly not
strongly opposed to it. I think the key is to approach it from the
standpoint that link-local scope DoS attacks such as DAD aren't really
something we need to protect against.

Thanks.
- Ed

---

---

From: Vijay Devarapalli <[email-masked]>
Date: Wed, 02 Jul 2003 13:29:09 -0700

Ed Remmell wrote:
> address) that Pascal is recommending? 

yup. going strong on it. :)

> If so, then why? 

we have been through the discussion. there is nothing new 
from me. any changes to a binding cache entry should come 
from an authenticated Binding Update.

Vijay